//+------------------------------------------------------------------+
//|                                                   ModableAMA.mq4 |
//|                                                       Vixen Girl |
//|                                                vixenme@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Vixen Girl"
#property link      "vixenme@gmail.com"

extern double     TakeProfit                    = 680.0;
extern double     Lots                          = 0.1;
extern double     TrailingStop                  = 68;

extern int        wrkPeriod                     = PERIOD_H1;
extern int        refPeriod                     = PERIOD_M15;

extern bool       Put1stSL                      = false;
extern int        SLlevel                       = 38;

extern bool       SLAutoCal                     = True;
extern int        SLAFactor                     = 28;

extern int        DojiFactor                    = 2;

extern double     FastBarTP                     = 180;
extern double     FastBarLots                   = 0.5;
extern bool       PutfastSL                     = true;
extern double     FastBarSLFctr                 = 28.0;
extern bool       FastSLAutoCal                 = True;
extern double     FastFactor                    = 20.0;
extern double     FOverFactor                   = 20.0;

extern int        BreakingFactor                = 20;

extern int        MagicNo                       = 333333333;
extern string     OrdComment                    =  "Tunnel&CP FAST";

extern int        SMMAPRD                       = 16;
extern double     ENVDIV                        = 0.08;

extern color      OpenBuy_Sig_Color             = DarkGoldenrod;
extern color      CloseBuy_Sig_Color            = Black;
extern color      OpenSell_Sig_Color            = Crimson;
extern color      CloseSell_Sig_Color           = Black;
extern color      Modified_Sig_Color            = DarkViolet;

extern bool       Enable_Sound                  = true;
extern string     Sound_OrderOpen_FileName      = "feelgood.wav";
extern string     Sound_OrderClose_FileName     = "iceburg.wav";
extern string     Sound_OrderModify_FileName    = "lion05.wav";

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNo)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
//---- Defind up-down PART

double UPPERENV   = iEnvelopes(NULL, wrkPeriod, SMMAPRD,MODE_SMMA,0,PRICE_CLOSE,ENVDIV,MODE_UPPER,0);
double LOWERENV   = iEnvelopes(NULL, wrkPeriod, SMMAPRD,MODE_SMMA,0,PRICE_CLOSE,ENVDIV,MODE_LOWER,0);
double SMMA       = iMA(NULL,wrkPeriod,SMMAPRD,0,MODE_SMMA,PRICE_CLOSE,0);

double highbk3  = iHigh(NULL,wrkPeriod,3);
double lowbk3   = iLow(NULL,wrkPeriod,3);
double closebk3 = iClose(NULL,wrkPeriod,3);
double openbk3  = iOpen(NULL,wrkPeriod,3);

double highbk2  = iHigh(NULL,wrkPeriod,2);
double lowbk2   = iLow(NULL,wrkPeriod,2);
double closebk2 = iClose(NULL,wrkPeriod,2);
double openbk2  = iOpen(NULL,wrkPeriod,2);

double highbk1  = iHigh(NULL,wrkPeriod,1);
double lowbk1   = iLow(NULL,wrkPeriod,1);
double closebk1 = iClose(NULL,wrkPeriod,1);
double openbk1  = iOpen(NULL,wrkPeriod,1);

double high  = iHigh(NULL,wrkPeriod,0);
double low   = iLow(NULL,wrkPeriod,0);
double close = iClose(NULL,wrkPeriod,0);
double open  = iOpen(NULL,wrkPeriod,0);

double openref  = iOpen(NULL,refPeriod,0);
double closeref = iClose(NULL,refPeriod,0);

double dif   = MathAbs(close-open)/Point;
double difref   = MathAbs(closeref-openref)/Point;
double bk1dif   = MathAbs(closebk1-openbk1)/Point;
double bk2dif   = MathAbs(closebk2-openbk2)/Point;
double bk3dif   = MathAbs(closebk3-openbk3)/Point;

double difOvUp   = MathAbs(close-UPPERENV)/Point;
double difOvDn   = MathAbs(LOWERENV-close)/Point;
double brknbullpt   = lowbk1-BreakingFactor*Point;
double brknbearpt   = highbk1+BreakingFactor*Point;

      double lowest  =Lowest(NULL,0,MODE_LOW,3,1);
      double lowestpt=iLow(NULL,0,lowest);

      double highest  =Highest(NULL,0,MODE_HIGH,3,1);
      double highestpt=iHigh(NULL,0,highest);
      
      double lowestBrkPt = lowestpt-BreakingFactor*Point;
      double highestBrkPt = highestpt+BreakingFactor*Point;

   if(difref>DojiFactor)
   {
         if(closeref>openref)       bool refbull=true;
         else/*(closeH1<openH1)*/   bool refbear=true;
   }else                            bool refdoji=true; 
   
   if(dif>DojiFactor)
   {
      if(close>open)
      {                       bool bull=true;
         if(refbull)          bool fwbull=true;
         else                 bool bwbull=true;
      }
      else/*(close<open)*/ 
      {                       bool bear=true;
         if(refbear)          bool fwbear=true;
         else                 bool bwbear=true;
      }
   }
   else                       bool doji=true;  

if       (open>UPPERENV && close>UPPERENV)bool upperbull=true;
else if  (open<LOWERENV && close<LOWERENV)bool lowerbear=true;
else                                      bool tunneling=true;

if       (open>SMMA && close>SMMA)bool uptrend=true;
else if  (open<SMMA && close<SMMA)bool dntrend=true;
else                              bool sideway=true;

if(open<UPPERENV && open>LOWERENV)
{
      if(close>UPPERENV && difOvUp>FastFactor && fwbull)bool fastup = true;
      if(close<LOWERENV && difOvDn>FastFactor && fwbear)bool fastdn = true;
}

if(open>UPPERENV && close<LOWERENV && difOvDn>FOverFactor && fwbull)bool FOdn=true;
if(open<LOWERENV && close>UPPERENV && difOvUp>FOverFactor && fwbear)bool FOup=true;

//------------------------------------------------------------------------+
if       (closebk1>openbk1 && bk1dif>DojiFactor) int bar1val=1;
else if  (closebk1<openbk1 && bk1dif>DojiFactor)     bar1val=-1;
else                                                 bar1val=0;

if       (closebk2>openbk2 && bk2dif>DojiFactor) int bar2val=1;
else if  (closebk2<openbk2 && bk2dif>DojiFactor)     bar2val=-1;
else                                                 bar2val=0;

if       (closebk3>openbk3 && bk3dif>DojiFactor) int bar3val=1;
else if  (closebk3<openbk3 && bk3dif>DojiFactor)     bar3val=-1;
else                                                 bar3val=0;
/*if       (close>open && dif>DojiFactor) int Cbarval=1;
else if  (close<open && dif>DojiFactor)     Cbarval=-1;
else                                        Cbarval=0;*/
int CurTrend=bar1val+bar2val+bar3val;

if       (CurTrend>0) bool bulltrend =true;
else if  (CurTrend<0) bool beartrend =true;
else/*(CurTrend==0) */bool swtrend   =true;

if(dntrend && bulltrend && fwbear && close<lowestBrkPt) bool brkdnbear=true;
if(uptrend && beartrend && fwbull && close>highestBrkPt)bool brkupbull=true;
if(beartrend && fwbull && close>highestBrkPt)bool brknhigh=true;
if(bulltrend && fwbear && close<lowestBrkPt) bool brknlow=true;
//------------------------------------------------------------------------+

if(uptrend && upperbull && bulltrend && fwbull)            bool fullybull =true;
if(uptrend && upperbull && beartrend && fwbull && brknhigh)bool BHbull    =true;
if(dntrend && lowerbear && beartrend && fwbear)            bool fullybear =true;
if(dntrend && lowerbear && bulltrend && fwbear && brknlow) bool BLbear    =true;
//-----------------------------------------------------------------------------+

//---- Defind up-down PART ENDED


//---- Auto Calculate Stop Loss due to the bar open price
//-------------------
double F1stStopLoss,SLAF2pips=SLAFactor*Point;
if(Put1stSL)
{
   if(SLAutoCal)
   {
      if(uptrend){F1stStopLoss=low-SLAF2pips;}
      if(dntrend){F1stStopLoss=high+SLAF2pips;}
   }//end if SLAutoCal
   else
   {
      if(uptrend){F1stStopLoss=Ask-SLlevel*Point;}
      if(uptrend){F1stStopLoss=Bid+SLlevel*Point;}
   }//end not SLAutoCal but put SL    
}else F1stStopLoss=0;
//---------------------
double FastBarSL;
if(PutfastSL)
{
   if(FastSLAutoCal)
   {
      if(fastup)FastBarSL=open;
      if(fastdn)FastBarSL=open;
      if(FOup || FOdn)FastBarSL=SMMA;
   }//end if FastSLAutoCal
   else
   {
      if(fastup||FOup)FastBarSL=Ask-FastBarSLFctr*Point;
      if(fastdn||FOdn)FastBarSL=Bid+FastBarSLFctr*Point;
   }//end not FastSLAutoCal but put fastSL 
}
else FastBarSL=0;
//---------------------
//---- Auto Calculate Stop Loss ENDED

      //---------------------
      if(fastup||FOup ||fastdn||FOdn)
      {
         double   RTakeProfit =  FastBarTP;
         double   LotSize     =  FastBarLots;
      }
      else
      {
         RTakeProfit =  TakeProfit;
         LotSize     =  Lots;
      }
      //---------------------


//---- Start Trade

int cnt, ticket,total;
int spread = MathRound((Ask-Bid)/Point);

//+------------------------------------------------------------------+
//| Don't Trade If Bars<100 & TakeProfit<5 & No Avilable Margin Left |
//+------------------------------------------------------------------+
if(Bars<100)Comment("bars less than 100");
else if(TakeProfit<5)Comment("TakeProfit less than 5");
else if(AccountFreeMargin()<(1000*Lots))Comment("You have no money. Free Margin = ", AccountFreeMargin());
//+------------------------------------------------------------------+
else{
   //---- Start Trading                                                  
   //+--------//Check for opened order in the same symbol//-------------+
   if(CalculateCurrentOrders(Symbol())==0)
   {
         //--------
         if(fullybull || BHbull || fastup || FOup)ticket=OrderSend(Symbol(),OP_BUY,LotSize,Ask,spread,F1stStopLoss,Ask+RTakeProfit*Point,OrdComment,MagicNo,0,OpenBuy_Sig_Color);
         if(fullybear || BLbear || fastdn || FOdn)ticket=OrderSend(Symbol(),OP_SELL,LotSize,Bid,spread,F1stStopLoss,Bid-RTakeProfit*Point,OrdComment,MagicNo,0,OpenSell_Sig_Color);
         //--------

      //+-----------------//Check END//----------------------------------+

      if(ticket>0)
      {
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
         {
            if (Enable_Sound) PlaySound(Sound_OrderOpen_FileName);
            Comment("\nAlert : ", TimeToStr(CurTime(),TIME_MINUTES),
                     "\nOrder Opened : ",OrderOpenPrice());
            Print("Order opened : ",OrderOpenPrice());
         return(0);
         }//end OrderSelect
      return(0);
      }//end ticket>0
      //else Print("Error opening order : ",GetLastError());
   return(0);
   }//end of CalculateCurrentOrders()
return(0);   
}//end else (trading)

   //+--------//Check for closing and modifying condition//-----------+
   total = OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
      {
         if(OrderType()==OP_BUY) // long position is opening
         {
            // should it be closed?
            if(dntrend)
            {
                     OrderClose(OrderTicket(),OrderLots(),Bid,spread,CloseBuy_Sig_Color);
                     // close position
                     if (Enable_Sound) PlaySound(Sound_OrderClose_FileName);
                     Comment("\nLong Order Closed : ",OrderComment(),
                              "\nAt : ",OrderClosePrice(),
                              "\nProfit : ",OrderProfit(),
                              "\nTime : ", TimeToStr(CurTime(),TIME_MINUTES));
            return(0); // exit
            }//end dntrend
      
            // check for trailing stop
            if(TrailingStop>0)
            {
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
               {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Modified_Sig_Color);
                     if (Enable_Sound) PlaySound(Sound_OrderModify_FileName);
                     Comment("\nOrder Modify Alert : ",TimeToStr(CurTime(),TIME_MINUTES),
                              "\nNew Stop Loss : ",OrderStopLoss(),
                              "\nTarget Profit : ",OrderTakeProfit());
                  return(0);
                  }//end OrderStopLoss()<Bid-Point*TrailingStop
               }//end Bid-OrderOpenPrice()>Point*TrailingStop
            }//end TrailingStop>0
         }//end OrderType()==OP_BUY
   
         else // go to short position
         {
            // should it be closed?
            if(uptrend)
            {
                  OrderClose(OrderTicket(),OrderLots(),Ask,spread,CloseSell_Sig_Color);
                  // close position
                  if (Enable_Sound) PlaySound(Sound_OrderClose_FileName);
                  Comment("\nShort Order Closed : ",OrderComment(),
                           "\nAt : ",OrderClosePrice(),
                           "\nProfit : ",OrderProfit(),
                           "\nTime : ", TimeToStr(CurTime(),TIME_MINUTES));
            return(0); // exit
            }//end uptrend

            // check for trailing stop
            if(TrailingStop>0)
            {
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Modified_Sig_Color);
                     if (Enable_Sound) PlaySound(Sound_OrderModify_FileName);
                        Comment("\nOrder Modify Alert : ",TimeToStr(CurTime(),TIME_MINUTES),
                                 "\nNew Stop Loss : ",OrderStopLoss(),
                                 "\nTarget Profit : ",OrderTakeProfit());
                  return(0);
                  }//end OrderStopLoss()
               }//end OrderOpenPrice()-Ask >(Point*TrailingStop)
            }//end TrailingStop>0
         }//end else
      }//end OrderType()<=OP_SELL && OrderSymbol()==Symbol()
   }//end for
//+----------------------------------------------------------------END



return(0);
}
//+------------------------------------------------------------------+